const spawn = require('cross-spawn');
const fs = require('fs-extra');
const path = require('path');

const packageName = 'postcss@^8';
function installDependencies(targetDir) {
  if (!process.env.CLOUDBASE_CIID) {
    return;
  }

  let yarnExists = false;
  // try {
  //   let { stdout } = spawn.sync('yarn', ['-v']);
  //   let str = stdout.toString();
  //   if (Number(str.split('.')?.[0]) <= 1) {
  //     yarnExists = true;
  //   }
  // } catch (e) {}

  const npmOptions = ['--prefer-offline', '--no-audit', '--progress=false', '--production', '--no-package-lock'];

  let installProcess;
  // 云端构建, 选用 npm
  const installlProcessOptions = {
    cwd: targetDir,
    env: { ...process.env, NODE_ENV: '' },
    stdio: 'inherit',
  };

  if (yarnExists && !process.env.CLOUDBASE_CIID) {
    const addPackage = packageName ? ['add', packageName] : [];

    installProcess = spawn.sync('yarn', [...addPackage], installlProcessOptions);
  } else {
    installProcess = spawn.sync('npm', ['install', packageName, ...npmOptions], installlProcessOptions);
  }

  try {
    fs.removeSync(path.join(path.join(targetDir, 'yarn.lock')));
  } catch (e) {
    console.log(e.message);
  }
}

// installDependencies(path.join(__dirname, '../'));
installDependencies('~/test/aaa/ttt/registry');
